commit 8fb4a0cc35c48878cca0b0e45e05d1533e9ba9ec
Author: root <root@nuedel.(none)>
Date:   Sun Jun 14 09:40:42 2009 +0200

    Even if mobile requests a SDCCH, we provide TCH_F.
    Because we cannot change channel, we must use this for now.

diff --git a/openbsc/src/abis_rsl.c b/openbsc/src/abis_rsl.c
index 4b2a7fc..2dcb0d2 100644
--- a/openbsc/src/abis_rsl.c
+++ b/openbsc/src/abis_rsl.c
@@ -856,6 +856,10 @@ static int rsl_rx_chan_rqd(struct msgb *msg)
 	lctype = get_ctype_by_chreq(bts, rqd_ref->ra);
 	chreq_reason = get_reason_by_chreq(bts, rqd_ref->ra);
 
+	/* This hack is required until we can modify channel type. */
+	if (chreq_reason != GSM_CHREQ_REASON_LOCATION_UPD)
+		lctype = GSM_LCHAN_TCH_F;
+
 	/* check availability / allocate channel */
 	lchan = lchan_alloc(bts, lctype);
 	if (!lchan) {
diff --git a/openbsc/src/gsm_04_08.c b/openbsc/src/gsm_04_08.c
index d5f12de..1e432de 100644
--- a/openbsc/src/gsm_04_08.c
+++ b/openbsc/src/gsm_04_08.c
@@ -1264,7 +1264,7 @@ static int mm_rx_loc_upd_req(struct msgb *msg)
 }
 
 /* 9.1.5 Channel mode modify */
-int gsm48_tx_chan_mode_modify(struct gsm_lchan *lchan, u_int8_t mode)
+static int gsm48_tx_chan_mode_modify(struct gsm_lchan *lchan, u_int8_t mode)
 {
 	struct msgb *msg = gsm48_msgb_alloc();
 	struct gsm48_hdr *gh = (struct gsm48_hdr *) msgb_put(msg, sizeof(*gh));
@@ -3417,7 +3417,8 @@ int mncc_send(struct gsm_network *net, int msg_type, void *arg)
 					ts = &trx->ts[k];
 					for (l = 0; l < TS_MAX_LCHAN; l++) {
 						lchant = &ts->lchan[l];
-						if (lchant->subscr == subscr) {
+						if (lchant->subscr == subscr
+								&&lchant->type == GSM_LCHAN_TCH_F) {
 							lchan = lchant;
 							break;
 						}
